if(!isFunction(ShapeBaseData, onRemove))
	eval("function ShapeBaseData::onRemove(%db, %obj) { }");

function quickRegisterPref(%name, %cat, %pref, %type, %default)
{
	%pref = trim(%pref);

	if(getSubStr(%pref, 0, 1) !$= "$")
		%pref = "$" @ %pref;

	eval("if(" @ %pref @ " $= \"\") " @ %pref @ " = \"" @ %default @ "\";");

	RTB_registerPref(%name, %cat, %pref, %type, fileBase($Con::File), %default, false, false, "");
}

quickRegisterPref("Default View Scale", "Minimap", "$Pref::MMG::defaultScale", "num 0.1 100", 1);
quickRegisterPref("Default Large View Scale", "Minimap", "$Pref::MMG::defaultLargeScale", "num 0.1 100", 1);
quickRegisterPref("Show Visible Friendlies", "Minimap", "$Pref::MMG::showFriendly", "list Never 0 Visible 1 FlagHolder 2 FlagOrVisible 3 Always 4", 4);
quickRegisterPref("Show Visible Enemies", "Minimap", "$Pref::MMG::showEnemy", "list Never 0 Visible 1 FlagHolder 2 FlagOrVisible 3 Always 4", 2);
quickRegisterPref("Enable Flag Icons", "Minimap", "$Pref::MMG::enableFlagIcons", "bool", true);
quickRegisterPref("Enable Icon Click Events", "Minimap", "$Pref::MMG::enableClickEvents", "bool", true);
quickRegisterPref("Enable Player Pings", "Minimap", "$Pref::MMG::enablePings", "bool", true);

exec("./methods.cs");
exec("./events.cs");

package MinimapServerPkg
{
	function GameConnection::onClientEnterGame(%cl, %x, %y)
	{
		if(!isEventPending($mmgt))
			MMGTick();

		%t = getRealTime();
		%cl.mmgTime = %t;
		commandToClient(%cl, 'MMGEnabled', %t);
		%cl.MMGSetViewScale($Pref::MMG::defaultScale);
		%cl.MMGSetViewScale($Pref::MMG::defaultLargeScale);
		return Parent::onClientEnterGame(%cl, %x, %y);
	}

	function Armor::onAdd(%db, %obj)
	{
		Parent::onAdd(%db, %obj);

		if(isObject(%obj) && isObject(%obj.client))
			%obj.schedule(0, MMGScopeAlwaysAll, "triangle");
	}

	function Armor::onDisabled(%db, %obj, %state)
	{
		if(isObject(%obj) && %obj.MMGScopeAlwaysAll)
			%obj.MMGScopeAlwaysAll("cross");

		Parent::onDisabled(%db, %obj, %state);
	}

	function Armor::onRemove(%db, %obj)
	{
		%obj.MMGUnscopeAll();

		Parent::onRemove(%db, %obj);
	}

	function ShapeBaseData::onRemove(%db, %obj)
	{
		%obj.MMGUnscopeAll();

		Parent::onRemove(%db, %obj);
	}

	function fxDtsBrick::onRemove(%obj)
	{
		if(isObject(%ico = %obj.iconObject))
			%ico.delete();
		
		Parent::onRemove(%obj);
	}
	
	function SimObject::onCameraEnterOrbit(%obj, %cam)
	{
		if(isObject(%cl = %cam.getControllingClient()))
			%cl.MMGRemovePlayerIcon();
		
		return Parent::onCameraLeaveOrbit(%obj, %cam);
	}

	function SimObject::onCameraLeaveOrbit(%obj, %cam)
	{
		if(isObject(%cl = %cam.getControllingClient()))
			%cl.MMGResetPlayerIcon();
		
		return Parent::onCameraLeaveOrbit(%obj, %cam);
	}

	function destroyServer()
	{
		cancel($mmgt);
		return Parent::destroyServer();
	}

	function Slayer_CTF::onFlagPickup(%this, %client, %team, %brick, %flag)
	{
		if(isObject(%pl = %client.player) && $Pref::MMG::enableFlagIcons)
			%pl.MMGScopeAlwaysAll("flag", "", "", true, 0.3);

		Parent::onFlagPickup(%this, %client, %team, %brick, %flag);
	}

	function Slayer_CTF::onFlagReturn(%this, %client, %team, %brick, %flag)
	{
		if(isObject(%pl = %client.player) && $Pref::MMG::enableFlagIcons)
		{
			%pl.MMGScopeAlwaysAll("triangle");
			%pl.schedule(50, MMGBlinkIconAll, 0);
		}

		Parent::onFlagReturn(%this, %client, %team, %brick, %flag);
	}

	function Slayer_CTF::onFlagDrop(%this, %client, %team, %brick, %flag)
	{
		if(isObject(%pl = %client.player) && $Pref::MMG::enableFlagIcons)
		{
			%pl.MMGScopeAlwaysAll("triangle");
			%pl.schedule(50, MMGBlinkIconAll, 0);
		}

		Parent::onFlagDrop(%this, %client, %team, %brick, %flag);
		
		if($Pref::MMG::enableFlagIcons)
			%flag.MMGScopeAlwaysAll("flag", "", getColorIDTable(%brick.getColorID()));
	}
};
activatePackage(MinimapServerPkg);

function serverCmdMMGOk(%cl, %t)
{
	if((%t | 0) == (%cl.mmgTime | 0)) // Why doesn't this work without the |0 ????????
		%cl.hasMMG = true;
}

function MMGTick()
{
	cancel($mmgt);

	if(!isObject(MMGSet))
	{
		new SimSet(MMGSet);
		MissionCleanup.add(MMGSet);
	}

	%cts = MMGSet.getCount();
	for(%i = 0; %i < %cts; %i++)
	{
		// %keep = false;
		%obj = MMGSet.getObject(%i);

		// if(%obj.MMGScopeAlwaysAll)
		// 	%keep = true;

		%ct2 = ClientGroup.getCount();
		for(%o = 0; %o < %ct2; %o++)
		{
			%cl = ClientGroup.getObject(%o);

			if(!%cl.hasMMG)
				continue;

			if(%obj.MMGScopedTo[%cl])
			{
				// %keep = true;
				%obj.MMGTick(%cl);
			}
			else if(%obj.MMGScopeAlways[%cl])
			{
				// %keep = true;

				if(%cl.MMGCanScope(%obj))
					%obj.MMGScope(%cl, %obj.MMGSAIcon[%cl], %obj.MMGSAName[%cl], %obj.MMGSAColor[%cl], %obj.MMGSADist[%cl], %obj.MMGSABlink[%cl]);
			}
			else if(%obj.MMGScopeAlwaysAll)
			{
				// %keep = true;
				%obj.MMGSAIcon[%cl] = %obj.MMGSAIcon;
				%obj.MMGSAName[%cl] = %obj.MMGSAName;
				%obj.MMGSAColor[%cl] = %obj.MMGSAColor;
				%obj.MMGSADist[%cl] = %obj.MMGSADist;
				%obj.MMGSABlink[%cl] = %obj.MMGSABlink;

				if(%cl.MMGCanScope(%obj))
					%obj.MMGScope(%cl, %obj.MMGSAIcon[%cl], %obj.MMGSAName[%cl], %obj.MMGSAColor[%cl], %obj.MMGSADist[%cl], %obj.MMGSABlink[%cl]);
			}
		}

		// if(!%keep)
		// 	MMGSet.schedule(0, remove, %obj);
	}

	$mmgt = schedule(100, 0, MMGTick);
}

function serverCmdMMGMapClicked(%cl, %pos)
{
	if($Pref::MMG::enablePings)
	{
		if(!isObject(%obj = %cl.pingObject))
		{
			%obj = new Item(mmgio)
			{
				datablock = emptyItem;
				position = %pos;
				static = true;
				iconClient = %cl.getId();
				isPingIcon = true;
			};

			%cl.pingObject = %obj;

			%obj.canPickup = false;

			%obj.cleanup = %obj.schedule(30000, delete);
		}
		else
		{
			cancel(%obj.cleanup);
			%obj.cleanup = %obj.schedule(30000, delete);
		}

		%obj.setTransform(%pos SPC getTerrainHeight(%pos));
		%obj.MMGScopeAlwaysAll("marker", %cl.name @ "'s ping", "", true, 0.5);
	}
}

function serverCmdMMGIconClicked(%cl, %pos, %ico)
{
	if(isObject(%ico))
		%ico.MMGOnClick(%cl, %pos);
}